_TITLE "Bat counter from word search" 'by B+ 2018-10-16 from
'Bat counter from word search.txt for JB [B+=MGA] 2018-10-16
' Happy Halloween! Here is your trick!
' Treat me with the correct count of BAT

DIM SHARED xy AS INTEGER 'for square block of letters xy is one side of square
xy = 20
DIM SHARED L$(1 TO xy, 1 TO xy), DX(1 TO 8) AS INTEGER, DY(1 TO 8) AS INTEGER
DX(1) = 1: DY(1) = 0
DX(2) = 1: DY(2) = 1
DX(3) = 0: DY(3) = 1
DX(4) = -1: DY(4) = 1
DX(5) = -1: DY(5) = 0
DX(6) = -1: DY(6) = -1
DX(7) = 0: DY(7) = -1
DX(8) = 1: DY(8) = -1

OPEN "BAT Letters.txt" FOR INPUT AS #1
FOR y = 1 TO xy
    INPUT #1, fline$
    FOR x = 1 TO xy
        L$(x, y) = MID$(fline$, x, 1)
    NEXT
NEXT
CLOSE #1
showPuzzle
FOR y = 1 TO xy
    FOR x = 1 TO xy
        IF L$(x, y) = "B" THEN
            FOR D = 1 TO 8
                'will BAT fit? from "B" at x, y
                b$ = ""
                b1 = 2 * DX(D) + x > 0 AND 2 * DX(D) + x <= xy
                b2 = 2 * DY(D) + y > 0 AND 2 * DY(D) + y <= xy
                IF b1 AND b2 THEN
                    b$ = "B": xx = x + DX(D): yy = y + DY(D)
                    FOR i = 2 TO 3
                        b$ = b$ + L$(xx, yy)
                        xx = xx + DX(D): yy = yy + DY(D)
                    NEXT
                    IF b$ = "BAT" THEN 'show our result
                        CLS
                        xx = x: yy = y
                        FOR i = 1 TO 3
                            LOCATE yy, 2 * xx - 1: PRINT L$(xx, yy);
                            xx = xx + DX(D): yy = yy + DY(D)
                        NEXT
                        batCount = batCount + 1
                        LOCATE xy + 2, 5: PRINT "Bat at ("; x; ", "; y; "), bat count = "; batCount
                        LOCATE xy + 4, 5: INPUT "OK, press enter when ready... "; wate$
                        showPuzzle
                    END IF
                END IF
            NEXT
        END IF
    NEXT
NEXT
LOCATE xy + 4, 5: PRINT "Total BATs found = "; batCount;
END

SUB showPuzzle
    CLS
    LOCATE 1, 1
    FOR y = 1 TO xy
        FOR x = 1 TO xy
            PRINT L$(x, y); " ";
        NEXT
        PRINT
    NEXT
    LOCATE xy + 2, 5: INPUT "OK, press enter when ready... "; wate$
END SUB



