_TITLE "TRICK or TREAT counter" ' for QB64 B+ 2018-10-16
'TRICK TREAT counter from word search.txt for JB [B+=MGA] 2018-10-16

DIM SHARED xCols AS INTEGER, yRows AS INTEGER 'for square block of letters xy is one side of square
xCols = 30: yRows = 20
DIM SHARED L$(1 TO xCols, 1 TO yRows)
DIM SHARED DX(1 TO 8) AS INTEGER, DY(1 TO 8) AS INTEGER
DX(1) = 1: DY(1) = 0
DX(2) = 1: DY(2) = 1
DX(3) = 0: DY(3) = 1
DX(4) = -1: DY(4) = 1
DX(5) = -1: DY(5) = 0
DX(6) = -1: DY(6) = -1
DX(7) = 0: DY(7) = -1
DX(8) = 1: DY(8) = -1

OPEN "TRICK TREAT Letters.txt" FOR INPUT AS #1
FOR y = 1 TO yRows
    INPUT #1, fline$
    FOR x = 1 TO xCols
        L$(x, y) = MID$(fline$, x, 1)
    NEXT
NEXT
CLOSE #1
showPuzzle
FOR y = 1 TO yRows
    FOR x = 1 TO xCols
        IF L$(x, y) = "T" THEN
            FOR D = 1 TO 8
                'will TRICK or TREAT fit? from "T" at x, y with 4 moves in one direction
                b$ = ""
                b1 = 4 * DX(D) + x > 0 AND 4 * DX(D) + x <= xCols
                b2 = 4 * DY(D) + y > 0 AND 4 * DY(D) + y <= yRows
                IF b1 AND b2 THEN
                    b$ = "T": xx = x + DX(D): yy = y + DY(D)
                    FOR i = 2 TO 5
                        b$ = b$ + L$(xx, yy)
                        xx = xx + DX(D): yy = yy + DY(D)
                    NEXT
                    IF b$ = "TRICK" OR b$ = "TREAT" THEN 'show our result
                        CLS
                        xx = x: yy = y
                        FOR i = 1 TO 5
                            LOCATE yy, 2 * xx - 1: PRINT L$(xx, yy);
                            xx = xx + DX(D): yy = yy + DY(D)
                        NEXT
                        IF b$ = "TRICK" THEN trickCount = trickCount + 1 ELSE treatCount = treatCount + 1
                        LOCATE yRows + 2, 5: PRINT "Trick or Treat at ("; x; ", "; y; "), Trick count = "; trickCount; ", Treat count = "; treatCount
                        LOCATE yRows + 4, 5: INPUT "OK, press enter when ready... "; wate$
                        showPuzzle
                    END IF
                END IF
            NEXT
        END IF
    NEXT
NEXT
LOCATE yRows + 4, 5: PRINT "Total TRICKs found = "; trickCount; ", Total TREATs found = "; treatCount;
END

SUB showPuzzle
    CLS
    LOCATE 1, 1
    FOR y = 1 TO yRows
        FOR x = 1 TO xCols
            PRINT L$(x, y); " ";
        NEXT
        PRINT
    NEXT
    LOCATE yRows + 2, 5: INPUT "OK, press enter when ready... "; wate$
END SUB
